Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# AttribNodeRegistry Class Reference

This global object records NodePaths that are referenced by scene graph attribs, such as ClipPlaneAttribs and LightAttribs. More...

List of all members.

## Public Member Functions
| addNode (NodePath const attrib_node)
| Adds the indicated NodePath to the registry.
| clear ()
| Removes all nodes from the registry.
int | findNode (NodePath const attrib_node)
| Returns the index number of the indicated NodePath in the registry (assuming its name hasn't changed since it was recorded in the registry), or -1 if the NodePath cannot be found (for instance, because its name has changed).
int | findNode (TypeHandle type, string name)
| Returns the index number of the node with the indicated type and name in the registry, or -1 if there is no such node in the registry.
NodePath | getNode (int n)
| Returns the nth NodePath recorded in the registry.
string | getNodeName (int n)
| Returns the name of the nth node, as recorded in the registry.
list | getNodes ()
TypeHandle | getNodeType (int n)
| Returns the type of the nth node, as recorded in the registry.
int | getNumNodes ()
| Returns the total number of nodes in the registry.
NodePath | lookupNode (NodePath const orig_node)
| Looks up the indicated NodePath in the registry.
| output (ostream out)
bool | removeNode (NodePath const attrib_node)
| Removes the indicated NodePath from the registry.
| removeNode (int n)
| Removes the nth node from the registry.
| write (ostream out)
## Static Public Member Functions
static AttribNodeRegistry | getGlobalPtr ()

## Detailed Description

This global object records NodePaths that are referenced by scene graph attribs, such as ClipPlaneAttribs and LightAttribs.

Its primary purpose is to unify attribs that are loaded in from bam files. Attrib nodes are identified by name and type; when a bam file that contains references to some attrib nodes is loaded, those nodes are first looked up here in the AttribNodeRegistry. If there is a match (by name and node type), the identified node is used instead of the node referenced within the bam file itself.

## Member Function Documentation

addNode | ( | NodePath const | attrib_node | ) |

Adds the indicated NodePath to the registry.

The name and type of the node are noted at the time of this call; if the name changes later, it will not update the registry index.

The NodePath must reference some kind of an attribute node, such as a LightNode or a PlaneNode. When bam files that reference an attribute node of the same type and the same name are loaded, they will quietly be redirected to reference this NodePath.

If there is already a node matching the indicated name and type, it will be replaced.

clear | ( |  | ) |

Removes all nodes from the registry.

int findNode | ( | NodePath const | attrib_node | ) |

Returns the index number of the indicated NodePath in the registry (assuming its name hasn't changed since it was recorded in the registry), or -1 if the NodePath cannot be found (for instance, because its name has changed).

int findNode | ( | TypeHandle | type,
|  | string | name
| ) |  |

Returns the index number of the node with the indicated type and name in the registry, or -1 if there is no such node in the registry.

static AttribNodeRegistry getGlobalPtr | ( |  | ) | `[static]`

NodePath getNode | ( | int | n | ) |

Returns the nth NodePath recorded in the registry.

string getNodeName | ( | int | n | ) |

Returns the name of the nth node, as recorded in the registry.

This will be the node name as it was at the time the node was recorded; if the node has changed names since then, this will still return the original name.

list getNodes | ( |  | ) |

TypeHandle getNodeType | ( | int | n | ) |

Returns the type of the nth node, as recorded in the registry.

int getNumNodes | ( |  | ) |

Returns the total number of nodes in the registry.

NodePath lookupNode | ( | NodePath const | orig_node | ) |

Looks up the indicated NodePath in the registry.

If there is a node already in the registry with the matching name and type, returns that NodePath instead; otherwise, returns the original NodePath.

output | ( | ostream | out | ) |

bool removeNode | ( | NodePath const | attrib_node | ) |

Removes the indicated NodePath from the registry.

The name of the node must not have changed since the matching call to add_node(), or it will not be successfully removed.

Returns true if the NodePath is found and removed, false if it is not found (for instance, because the name has changed).

removeNode | ( | int | n | ) |

Removes the nth node from the registry.

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties